from irods_http_client.models.metadata import iRODSMetaCollection
import os

class iRODSDataObject(object):
    
    base_query_string = "select DATA_ID, DATA_NAME, DATA_SIZE, DATA_MODIFY_TIME where DATA_COLL_ID = '{0}' and DATA_NAME='{1}'"
    metadata_query_string = "select META_DATA_ATTR_NAME, META_DATA_ATTR_VALUE, META_DATA_ATTR_UNITS, META_DATA_CREATE_TIME, META_DATA_MODIFY_TIME where DATA_NAME = '{0}'"
    
    def __init__(self, manager, parent=None, result=None):
        self.manager = manager
        if parent:
            self.collection = parent
        
        if result:
            self.id = result[0]
            self.name = result[1]
            self.size = result[2]
            self.modify_time = result[3]
            self.path = os.path.join(self.collection.path, self.name)
        self._meta = None
        
    
    def __repr__(self):
        return "<iRODSDataObject {id} {name}>".format(**vars(self))
    
    
    def _get_metadata(self):
        return self.manager.sess.queries.execute_genquery(self.metadata_query_string.format(self.name), parser='genquery2')['data']['rows']
    
    @property
    def metadata(self):
        if not self._meta:
            self._meta = iRODSMetaCollection(self, self.path)
        return self._meta